const HEIGHT = 21
const WIDTH = 79
const TRUE = 1
mstruct map {
	OLD rb WIDTH * HEIGHT
	NEW rb WIDTH * HEIGHT
}

main()
end

def main() {
	var gen
	cls
	cursor 0
	init(map.NEW)
	gen = 0
	while TRUE
		if (inkey() == 0x1b) {
			break
		}
		disp(gen, map.NEW)
		evolve(map.OLD, map.NEW)
		gen = gen + 1
	wend
}

def init(map) {
	var x
	var y
	var v
	for y = 0 to HEIGHT - 1
		for x = 0 to WIDTH - 1
			v = rnd(11)
			if (v < 2) {
				v = 1
			} else {
				v = 0
			}
			set(map, x, y, v)
		next
	next
}

def disp(gen, map) {
	var x
	var y
	var v
	locate 0, 21
	print "\x1b[32m";
	print gen;
	print "\x1b[33m";
	locate 0, 0
	for y = 0 to HEIGHT - 1
		for x = 0 to WIDTH - 1
			v = get(map, x, y)
			if (v) {
				print chr$(0x90);
			} else {
				print " ";
			}
		next
		print
	next
}

def evolve(old, new) {
	var x
	var y
	var v
	var count
	mmove(old, new, WIDTH * HEIGHT)
	for y = 0 to HEIGHT - 1
		for x = 0 to WIDTH - 1
			v = get(old, x, y)
			count = getCount(old, x, y)
			if (count == 3) {
				v = 1
			} else if (count == 4) {
			} else {
				v = 0
			}
			set(new, x, y, v)
		next
	next
}

' 周囲8個の生存数を数えます。
def getCount(map, x, y) {
	var count
	var i
	var xx
	var yy
	count = 0
	for i = 0 to 8
		xx = x + i % 3 - 1
		yy = y + i / 3 - 1
		count = count + get(map, adjustX(xx), adjustX(yy))
	next
	return count
}

def adjustX(x) {
	if (x < 0) {
		x = WIDTH - 1
	}
	if (WIDTH - 1 < x) {
		x = 0
	}
	return x
}

def adjustY(y) {
	if (y < 0) {
		y = HEIGHT - 1
	}
	if (HEIGHT - 1 < y) {
		y = 0
	}
	return y
}

' map[x, y]にVを設定します。
def set(map, x, y, v) {
	map[y * WIDTH + x] = v
}

' map[x, y]の値を取得します。
def get(map, x, y) {
	return map[y * WIDTH + x]
}
