extern wifiStatus, 3
extern wifiServerNew, 7
extern wifiClientNew, 8
extern wifiServerBegin, 9
extern wifiServerHasClient, 10
extern wifiServerAvailable, 11
extern wifiClientConnected, 12
extern wifiClientAvailable, 13
extern wifiClientRead, 14
extern wifiClientStop, 15
extern wifiClientPrintln, 16
extern wifiClientPrint, 17
const WL_CONNECTED = 3
const TRUE = 1
const FALSE = 0
mstruct str {
	EMPTY ds ""
	L1 ds "HTTP/1.1 200 OK"
	L2 ds "Content-type:text/html"
	L3 ds " <a href=\"/C\">[C]</a> "
	L4 ds " <a href=\"/D\">[D]</a> "
	L5 ds " <a href=\"/E\">[E]</a> <br>"
	GET_C ds "GET /C"
	GET_D ds "GET /D"
	GET_E ds "GET /E"
}
mstruct cmd {
	LN rb 100
}

main()
end

def main() {
	var server
	var client
	var c
	var i
	if (wifiStatus() != WL_CONNECTED) {
		return
	}
	server = wifiServerNew(80)
	wifiServerBegin(server)
	while TRUE
		if (inkey() == 0x1b) {
			end
		}
		client = wifiServerAvailable(server)
		if (!client) {
			continue
		}
		print "New Client."
		i = 0
		cmd.LN[0] = 0
		while wifiClientConnected(client)
			if (!wifiClientAvailable(client)) {
				continue
			}
			c = wifiClientRead(client)
			print chr$(c);
			if (c == '\n') {
				if (mstrlen(cmd.LN) == 0) {
					wifiClientPrintln(client, str.L1)
					wifiClientPrintln(client, str.L2)
					wifiClientPrintln(client, str.EMPTY)
					wifiClientPrintln(client, str.L3)
					wifiClientPrintln(client, str.L4)
					wifiClientPrintln(client, str.L5)
					wifiClientPrintln(client, str.EMPTY)
					break
				} else {
					i = 0
					cmd.LN[i] = 0
				}
			} else if (c != '\r') {
				cmd.LN[i] = c
				i = i + 1
				cmd.LN[i] = 0
			}
			if (endsWith(cmd.LN, str.GET_C)) {
				beep 24, 200
			} else if (endsWith(cmd.LN, str.GET_D)) {
				beep 26, 200
			} else if (endsWith(cmd.LN, str.GET_E)) {
				beep 28, 200
			}
		wend
		wifiClientStop(client)
		print "Client Disconnected."
	wend
}

' strがsuffixで終わっているかどうかを判定します。
def endsWith(str, suffix) {
	var p
	var q
	p = str + mstrlen(str) - 1
	q = suffix + mstrlen(suffix) - 1
	while suffix <= q
		if (p[0] != q[0]) {
			return FALSE
		}
		p = p - 1
		q = q - 1
	wend
	return TRUE
}
