'
' ORANGE Operating System
' typeコマンド
' Copyright (C) 2020 PicoSoft
' type <テキストファイル名>
' テキストファイルの中身をコンソールに表示します。
'
const MAX_PATH = 128
const BUF_SIZE = 256
mstruct str {
	EMPTY_STRING ds ""
	SLASH ds "/"
}
alias str.ROOT, str.SLASH
mstruct path {
	PATH rb MAX_PATH
}
mstruct env {
	DRIVE rb 3 // "f":, "s:"
	PATH_F rb MAX_PATH // f:のカレントパス
	PATH_S rb MAX_PATH // s:のカレントパス
}
mstruct work {
	COMMAND rb MAX_PATH
	NAME rb MAX_PATH
	BUF rb BUF_SIZE
}

main()
end

def main() {
	var file
	var size
	var i
	var c
	var path
	getenv "COMMAND", work.COMMAND // コマンドライン取得
	getArg(work.COMMAND, 1, work.NAME) // 1番目のパラメーター取得
	if (mstrcmp(work.NAME , str.EMPTY_STRING) = 0) {
		print "type <file name>"
		end
	}
	getFullPath(path.PATH, work.NAME)
	file = fopen(path.PATH, 0)
	if file = -1 {
		print "File not found"
		end
	}
	while 1
		size = fread(file, work.BUF, BUF_SIZE)
		for i = 0 to size - 1
			c = work.BUF[i]
			if (c = '\n') {
				print chr$('\r');
			}
			print chr$(c);
		next
		if (size != BUF_SIZE) {
			break
		}
	wend
	fclose(file)
}

' n番目の引数を取得します。
def getArg(p, n, arg) {
	var i
	var j
	var c
	for j = 0 to n
		for i = 0 to 255
			c = p[0]
			p = p + 1
			if (c = ' ' || c = 0) {
				break
			}
			arg[i] = c
		next
	next
	arg[i] = 0
}

' 完全パス名を作ります。
def getFullPath(fullPath, name) {
	var p
	var currentPath
	getenv "DRIVE", env.DRIVE // カレントドライブ取得
	getenv "PATH_F", env.PATH_F // カレントディレクトリ取得
	getenv "PATH_S", env.PATH_S // カレントディレクトリ取得
	p = name
	if (p[1] == ':') { // ドライブ指定あり
		fullPath[0] = p[0]
		fullPath[1] = p[1]
		fullPath[2] = 0
		p = p + 2
	} else {
		mstrcpy(fullPath, env.DRIVE) // カレントドライブ
	}
	if (p[0] == '/') { // ルートからの指定
		mstrcat(fullPath, p)
		return
	}
	if (fullPath[0] == 'f') {
		currentPath = env.PATH_F
	} else {
		currentPath = env.PATH_S
	}
	mstrcat(fullPath, currentPath)
	if (mstrcmp(currentPath, str.ROOT) != 0) {
		mstrcat(fullPath, str.SLASH)
	}
	mstrcat(fullPath, p)
}
